# Bio334

This is the Renku project for the course [Bio334](https://studentservices.uzh.ch/uzh/anonym/vvz/index.html#/details/2019/004/SM/50628703) and just a note that this project was initially forked from [Laurent Gatto's course run at UC Louvain](https://renkulab.io/gitlab/laurent.gatto/wsbim1207).


## Working with the project

The simplest way to start your project is right from the Renku
platform - just click on the `Environments` tab and start a new session.
This will start an interactive environment right in your browser.

Please see [the documentation](https://renku.readthedocs.io/en/latest/) for 
more details about Renku.

## How the images were built

So, the stack to build the images that work on Renku is a bit convoluted, so here is a description of the layers of layers that are involved. This is mostly left as a memento to remind myself how I did it. If I were to do it again, it would probably be worth organizing it all into one github repo.

First, we took an image from rocker (I think Carl Boettiger is to thank for these; these were freshly built following the recent change to `R 4.0.0`) and I uploaded it to my own dockerhub, like this:

```
docker pull rockerdev/rstudio:4.0.0
docker tag rockerdev/rstudio:4.0.0 markrobinsonuzh/renku:r4.0.0
docker push markrobinsonuzh/renku:r4.0.0
```

Second, I modified the earlier Bioconductor (many things had changed due to `rockerdev/rstudio:4.0.0` using Ubuntu 20.04) and add a bunch of the bioconductor components (note: my fork of the BioC repo; ), as follows:

```
docker build -t bioconductor_docker:4.0.0 https://github.com/markrobinsonuzh/bioconductor_docker.git
docker tag bioconductor_docker:4.0.0 markrobinsonuzh/renku:r4.0.0_bioc
docker push markrobinsonuzh/renku:r4.0.0_bioc
```

Note: [markrobinsonuzh/bioconductor_docker](https://github.com/markrobinsonuzh/bioconductor_docker) is forked from [Bioconductor/bioconductor_docker](https://github.com/Bioconductor/bioconductor_docker).

Next, using Renku's previous docker builds (I'll thank Rok and Emma and Christine here, possibly others!), the tools that are needed under the hood of Renku are added:

```
docker build -t markrobinsonuzh/renku:r4.0.0_bioc_renku https://github.com/markrobinsonuzh/renkulab-docker.git\#:docker/bioc
docker push markrobinsonuzh/renku:r4.0.0_bioc_renku
```

Note: [markrobinsonuzh/renkulab-docker](https://github.com/markrobinsonuzh/renkulab-docker) is forked from [SwissDataScienceCenter/renkulab-docker](https://github.com/SwissDataScienceCenter/renkulab-docker).

And then, it's _just_ from Renku:

```
docker build -t markrobinsonuzh/renku:r4.0.0_bioc_renku_bio334ss2020 https://renkulab.io/gitlab/mark.robinson/bio334_spring2020.git
docker push markrobinsonuzh/renku:r4.0.0_bioc_renku_bio334ss2020
```

This latter one was also built within Renku's builders, so that it can be served up for our course.
